/***************************************************************************
 *   Copyright (C) 2004 by Michael Moritz                                  *
 *   mimo@restoel.net                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DBDEFS_H
#define DBDEFS_H

#include <stdexcept>
#include "wlmodule.h"
#include "triplet.h"

/**
@author Michael Moritz
*/

class WLStaticDef
{
public:
	const char* _tableName;
	const char* _testTable;
	const char* _createTable[MAX_CREATECMDS];
	const char* _primaryKey;
	WlModule::CompareMode _compareMode;
	const char* _searchTable;
	WLCompares _compares;
	const char* _commentField;
};
const WLStaticDef& g_getTripletDef();
const WLStaticDef& g_getWlDef(const std::string& tableName) throw (std::out_of_range);
#endif
