/***************************************************************************
 *   Copyright (C) 2004 by Michael Moritz                                  *
 *   mimo@restoel.net                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef __TMPLWLMOD_H
#define __TMPLWLMOD_H

#include "wlmodule.h"
#include "wldb.h"

template <class Backend>
class TmplWlMod : public WlModule
{
public:
	TmplWlMod(class DB& db,
		bool initmode,
		const WLStaticDef& staticDef) throw(std::exception)
	: _backend(db,initmode,staticDef)
	{ }
	virtual ~TmplWlMod() {}
	virtual bool check(const class Triplet& triplet) {
		return _backend.check(triplet);
	}
private:
	Backend _backend;
};
#endif
